/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Rewriter.xs. Do not edit this file, edit Rewriter.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Rewriter.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

unsigned char paethPredictor(unsigned char a, unsigned char b, unsigned char c) {
  unsigned int p = a + b - c;
  unsigned int pa = abs((int)(p - a));
  unsigned int pb = abs((int)(p - b));
  unsigned int pc = abs((int)(p - c));

  if (pa <= pb && pa <= pc)
    return a;

  if (pb <= pc)
    return b;

  return c;
}

void filterRowNone(unsigned char* src, unsigned char* dst, size_t row, size_t bytes) {
  return;
}

void filterRowSub(unsigned char* src, unsigned char* dst, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t aix = xix;
  xix += pwidth;
  while (xix < (row+1)*bytes)
    dst[xix++] -= src[aix++];
}

void filterRowUp(unsigned char* src, unsigned char* dst, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  if (row == 0)
    return;
  while (xix < (row+1)*bytes)
    dst[xix++] -= src[bix++];
}

void filterRowAvg(unsigned char* src, unsigned char* dst, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  size_t aix;

  if (row == 0) {
    size_t aix = xix;
    xix += pwidth;
    while (xix < (row+1)*bytes)
      dst[xix++] -= src[aix++] >> 1;
    return;
  }

  aix = xix;
  for (; pwidth > 0; --pwidth)
    dst[xix++] -= src[bix++] >> 1;
  
  while (xix < (row+1)*bytes)
    dst[xix++] -= (src[aix++] + src[bix++]) >> 1;
}

void filterRowPaeth(unsigned char* src, unsigned char* dst, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  size_t aix, cix;

  if (row == 0) {
    size_t aix = xix;
    xix += pwidth;
    while (xix < (row+1)*bytes)
      dst[xix++] -= paethPredictor(src[aix++], 0 , 0);
    return;
  }

  aix = xix;
  cix = aix - bytes;

  for (; pwidth > 0; --pwidth)
    dst[xix++] -= paethPredictor(0, src[bix++] , 0);
  
  while (xix < (row+1)*bytes)
    dst[xix++] -= paethPredictor(src[aix++], src[bix++], src[cix++]);
}

void unFilterRowNone(unsigned char* idat, size_t row, size_t bytes) {
  return;
}

void unFilterRowSub(unsigned char* idat, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t aix = xix;
  xix += pwidth;
  while (xix < (row+1)*bytes)
    idat[xix++] += idat[aix++];
}

void unFilterRowUp(unsigned char* idat, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  if (row == 0)
    return;
  while (xix < (row+1)*bytes)
    idat[xix++] += idat[bix++];
}

void unFilterRowAvg(unsigned char* idat, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  size_t aix;

  if (row == 0) {
    size_t aix = xix;
    xix += pwidth;
    while (xix < (row+1)*bytes)
      idat[xix++] += idat[aix++] >> 1;
    return;
  }

  aix = xix;
  for (; pwidth > 0; --pwidth)
    idat[xix++] += idat[bix++] >> 1;
  
  while (xix < (row+1)*bytes)
    idat[xix++] += (idat[aix++] + idat[bix++]) >> 1;
}

void unFilterRowPaeth(unsigned char* idat, size_t row, size_t pwidth, size_t bytes) {
  size_t xix = row * bytes + 1;
  size_t bix = xix - bytes;
  size_t aix, cix;

  if (row == 0) {
    size_t aix = xix;
    xix += pwidth;
    while (xix < (row+1)*bytes)
      idat[xix++] += paethPredictor(idat[aix++], 0 , 0);
    return;
  }

  aix = xix;
  cix = aix - bytes;

  for (; pwidth > 0; --pwidth)
    idat[xix++] += paethPredictor(0, idat[bix++] , 0);
  
  while (xix < (row+1)*bytes)
    idat[xix++] += paethPredictor(idat[aix++], idat[bix++] , idat[cix++]);
}

void unFilterIdat(unsigned char* idat, size_t rows, size_t pwidth, size_t bytes) {
  size_t row;
  for (row = 0; row < rows; ++row) {
    switch(idat[row*bytes]) {
    case 0:
      break;
    case 1:
      unFilterRowSub(idat, row, pwidth, bytes);
      break;
    case 2:
      unFilterRowUp(idat, row, pwidth, bytes);
      break;
    case 3:
      unFilterRowAvg(idat, row, pwidth, bytes);
      break;
    case 4:
      unFilterRowPaeth(idat, row, pwidth, bytes);
      break;
    default:
      croak("bad filter type");
    }
    idat[row*bytes] = 0;
  }
}

void filterIdat(unsigned char* src, unsigned char* dst, unsigned char* filter, size_t rows, size_t pwidth, size_t bytes) {
  size_t row;
  for (row = 0; row < rows; ++row) {
    switch(filter[row]) {
    case 0:
      break;
    case 1:
      filterRowSub(src, dst, row, pwidth, bytes);
      break;
    case 2:
      filterRowUp(src, dst, row, pwidth, bytes);
      break;
    case 3:
      filterRowAvg(src, dst, row, pwidth, bytes);
      break;
    case 4:
      filterRowPaeth(src, dst, row, pwidth, bytes);
      break;
    default:
      croak("bad filter type");
    }
    dst[row*bytes] = filter[row];
  }
}


#line 211 "Rewriter.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 355 "Rewriter.c"

XS_EUPXS(XS_Image__PNG__Rewriter__unfilter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__PNG__Rewriter__unfilter)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "idat, rows, pwidth, bytes");
    {
	unsigned char*	idat = (unsigned char *)SvPV_nolen(ST(0))
;
	size_t	rows = (size_t)SvUV(ST(1))
;
	size_t	pwidth = (size_t)SvUV(ST(2))
;
	size_t	bytes = (size_t)SvUV(ST(3))
;
#line 210 "Rewriter.xs"
    unFilterIdat(idat, rows, pwidth, bytes);
#line 374 "Rewriter.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Image__PNG__Rewriter__filter); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__PNG__Rewriter__filter)
{
    dVAR; dXSARGS;
    if (items != 6)
       croak_xs_usage(cv,  "src, dst, filters, rows, pwidth, bytes");
    {
	unsigned char*	src = (unsigned char *)SvPV_nolen(ST(0))
;
	unsigned char*	dst = (unsigned char *)SvPV_nolen(ST(1))
;
	unsigned char*	filters = (unsigned char *)SvPV_nolen(ST(2))
;
	size_t	rows = (size_t)SvUV(ST(3))
;
	size_t	pwidth = (size_t)SvUV(ST(4))
;
	size_t	bytes = (size_t)SvUV(ST(5))
;
#line 221 "Rewriter.xs"
    filterIdat(src, dst, filters, rows, pwidth, bytes);
#line 401 "Rewriter.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Image__PNG__Rewriter); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Image__PNG__Rewriter)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Image::PNG::Rewriter::_unfilter", XS_Image__PNG__Rewriter__unfilter);
        newXS_deffile("Image::PNG::Rewriter::_filter", XS_Image__PNG__Rewriter__filter);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
